"""
15-110 Hw6 - Language Modeling Project
Name: 
AndrewID:
"""

project = "WordPredict" # don't edit this

#### CHECK-IN 1 ####

'''
Write a function load_book(filename) that takes a filename, opens it, and
creates a 2D list where each row is a sentence in the book, and each column is
one word or symbol in that sentence in order. The 2D list is called a corpus of text.
The file you are given is already cleaned - each line is a single sentence, all
words are lowercases, and all punctuation is separated out by spaces.
You should read in the file, and for each line, split it by spaces, and append
that list to your list of lists. For example, 

"Hello and welcome to 15-110. 
We're happy to have you." 

would return a 2D list

[ ["hello","and","welcome","to","15-110","."],
  ["we're","happy","to","have","you","."] ]
'''
def load_book(filename):
    return


'''
Write a function get_corpus_length(corpus) which is given a 2D list of words and
symbols in a text and returns the total number of single words or punctuation
symbols (called unigrams), e.g., "hello", ",", or "world".
corpus = [ ["hello", "world"],
            ["hello", "world", "again"] ]
get_corpus_length(corpus) -> 5

In the example from load_book, get_corpus_length would return 12.
'''
def get_corpus_length(corpus):
    return

"""
Given a 2D list corpus, write a function build_vocabulary that creates a new list
and iterates through the 2D list adding only words that are not present in the
new list already. In other words, it should return a list of all unique unigrams.

corpus = [ ["hello", "world"],
           ["hello", "world", "again"] ]
build_vocabulary(corpus) -> ["hello", "world", "again"]

corpus = [ ["hello","and","welcome","to","15-110","."],
           ["we're","happy","to","have","you","."]      ]
build_vocabulary(corpus) -> ["hello","and","welcome","to","15-110",".","we're",
                             "happy","have","you"]
"""
def build_vocabulary(corpus):
    return

"""
Given a 2D list corpus, write a function count_unigrams(corpus) which creates a
new dictionary with keys as each item in build_vocabulary(corpus) and values
initialized or set to 0. Then, iterate through the 2D list and for each
unigram, add one to the count of the number of times it was seen. Return the
dictionary with the counts of each unique unigram in the corpus.
Don't forget: a unigram is a single word or punctuation symbol, e.g., "hello",
",", or "world".

corpus = [ ["hello", "world"],
            ["hello", "world", "again"] ]
count_unigrams(corpus) -> { "hello": 2, "world": 2, "again": 1 }
"""
def count_unigrams(corpus):
    return

"""
Given a 2D list corpus, write a function get_start_words that creates a new list
and iterates through the 2D list, adding only the first words in the sentence that
it has not seen before. In other words, it should return a list of all unique
first words.

corpus = [ ["hello", "world"],
           ["hello", "world", "again"] ]
get_start_words(corpus) -> ["hello"]

corpus = [ ["hello","and","welcome","to","15-110","."],
           ["we're","happy","to","have","you","."]      ]
get_start_words(corpus) -> ["hello","we're"]
"""
def get_start_words(corpus):
    return

"""
Given a 2D list corpus, write a function count_start_words(corpus) which creates a
new dictionary with keys as each item in get_start_words(corpus) and values
initialized or set to 0. Then, iterate through the 2D list and for each
start word, add one to the count of the number of times it was seen. Return the
dictionary with the counts of each unique start word in the corpus.

corpus = [ ["hello", "world"],
            ["hello", "world", "again"] ]
count_start_words(corpus) -> { "hello": 2 }
"""
def count_start_words(corpus):
    return

"""
A bigram is a pair of words that appear next to each other. Often, looking at the
frequency of pairs of words helps us know more about what word goes next in a sentence
instead of only looking at single words (unigrams).

Write a function count_bigrams(corpus) that returns a 2D dictionary with the
counts of each unique bigram in the corpus. In order to do this, you will:
Step 1: create a new dictionary
Step 2: iterate through each sentence of the corpus.
Step 3: For each sentence, loop through the indexes of the words in each
sentence from 0 to n-1 (don't include the last word). With a word at index i,
each pair of words will be sentence[i] and sentence[i+1].
Step 4: If sentence[i] is not in your main dictionary, add it with the value
as an empty dictionary.
Step 5: Check if sentence[i+1] is in sentence[i]'s dictionary. If it is not, add
sentence[i+1] as the key and value 1. If it is in the dictionary, add 1 to the count.

This function should return the dictionary of dictionaries (2D dictionary) 
representing the counts of all bigrams of words.

corpus = [ ["hello", "world"],
            ["hello", "world", "again"] ]
bigram_count = count_bigrams(corpus)
bigram_count -> { "hello": { "world": 2 },
                    "world": { "again": 1 } }
bigram_count["hello"]["world"] -> 2
"""
def count_bigrams(corpus):
    return


def do_week1():
    book = load_book("data/fairytales_clean.txt")
    length = get_corpus_length(book)
    uniquewords = build_vocabulary(book)
    countunigrams = count_unigrams(book)
    countstartwords = count_start_words(book)
    countbigrams = count_bigrams(book)

#### WEEK 1 TESTS ####

def test_load_book():
    print("Testing load_book()...", end="")
    # We'll test with two shorts files, test1.txt and test2.txt
    # Open them up to see the contents!
    assert(load_book("data/test1.txt") == [ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ])
    assert(load_book("data/test2.txt") == [ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ])
    print("... done!")

def test_get_corpus_length():
    print("Testing get_corpus_length()...", end="")
    assert(get_corpus_length([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ]) == 5)
    assert(get_corpus_length([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ]) == 12)
    assert(get_corpus_length([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ]) == 41)
    print("... done!")

def test_build_vocabulary():
    print("Testing build_vocabulary()...", end="")
    assert(sorted(build_vocabulary([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ])) == sorted([ "hello", "world", "again"]))
    assert(sorted(build_vocabulary([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ])) == sorted([ "hello", "and",
         "welcome", "to", "15-110", ".", "we're", "happy", "have", "you"]))
    assert(sorted(build_vocabulary([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
        "because", ".", ".", "."] ])) == sorted([ "this", "is", "the", "song", 
        "that", "never", "ends", "yes", "it", "goes", "on", "and", "my", "friends", 
        "!", "some", "people", "started", "singing", ",", "not", "knowing", "what", 
        "was", "now", "they", "keep", "forever", "just", "because", "." ]))
    print("... done!")

def test_count_unigrams():
    print("Testing count_unigrams()...", end="")
    assert(count_unigrams([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ]) == { "hello" : 2, "world" : 2, "again" : 1 })
    assert(count_unigrams([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ]) == { "hello" : 1, "and" : 1,
        "welcome" : 1, "to" : 2, "15-110" : 1, "." : 2, "we're" : 1, "happy" : 1, 
        "have" : 1, "you" : 1 })
    assert(count_unigrams([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ]) == { "this" : 1, "is" : 1, "the" : 1, 
         "song" : 1, "that" : 1, "never" : 1, "ends" : 1, "yes" : 1, "it" : 4, 
         "goes" : 1, "on" : 3, "and" : 2, "my" : 1, "friends" : 1, "!" : 1, 
         "some" : 1, "people" : 1, "started" : 1, "singing" : 2, "," : 2, 
         "not" : 1, "knowing" : 1, "what" : 1, "was" : 1, "now" : 1, "they" : 1, 
         "keep" : 1, "forever" : 1, "just" : 1, "because" : 1, "." : 3 })
    print("... done!")

def test_get_start_words():
    print("Testing get_start_words()...", end="")
    assert(get_start_words([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ]) == [ "hello" ])
    assert(sorted(get_start_words([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ])) == sorted(["hello", "we're"]))
    assert(sorted(get_start_words([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ])) == sorted(["this", "yes", "some", "and"]))
    print("... done!")

def test_count_start_words():
    print("Testing count_start_words()...", end="")
    assert(count_start_words([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ]) == { "hello" : 2 })
    assert(count_start_words([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ]) == { "hello" : 1, "we're" : 1 })
    assert(count_start_words([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ]) == { "this" : 1, "yes" : 1, "some" : 1, "and" : 1 })
    print("... done!")

def test_count_bigrams():
    print("Testing count_bigrams()...", end="")
    assert(count_bigrams([ 
        ["hello", "world"], 
        ["hello", "world", "again"] ]) == { "hello" : { "world" : 2 },
        "world" : { "again" : 1 } })
    assert(count_bigrams([ 
        ["hello", "and", "welcome", "to", "15-110", "."],
        ["we're", "happy", "to", "have", "you", "."] ]) == { "hello" : { "and" : 1 },
        "and" : { "welcome" : 1 }, "welcome" : { "to" : 1 }, 
        "to" : { "15-110" : 1, "have" : 1 }, "15-110" : { "." : 1 },
        "we're" : { "happy" : 1 }, "happy" : { "to" : 1 }, "have" : { "you" : 1 },
        "you" : { "." : 1 } })
    assert(count_bigrams([ 
        ["this", "is", "the", "song", "that", "never", "ends"],
        ["yes", "it", "goes", "on", "and", "on", "my", "friends", "!"],
        ["some", "people", "started", "singing", "it", ",", "not", "knowing", 
         "what", "it", "was", ","],
        ["and", "now", "they", "keep", "on", "singing", "it", "forever", "just",
         "because", ".", ".", "."] ]) == { "this" : { "is" : 1 }, 
         "is" : { "the" : 1 }, "the" : { "song" : 1 }, "song" : { "that" : 1 }, 
         "that" : { "never" : 1 }, "never" : { "ends" : 1 }, "yes" : { "it" : 1 }, 
         "it" : { "goes" : 1, "," : 1, "was" : 1, "forever" : 1 }, 
         "goes" : { "on" : 1 }, "on" : { "and" : 1, "my" : 1, "singing" : 1 }, 
         "and" : { "on" : 1, "now" : 1 }, "my" : { "friends" : 1}, 
         "friends" : { "!" : 1 }, "some" : { "people" : 1 }, 
         "people" : { "started" : 1 }, "started" : { "singing" : 1 }, 
         "singing" : { "it" : 2 }, "," : { "not" : 1 }, "not" : { "knowing" : 1 },
         "knowing" : { "what" : 1 }, "what" : { "it" : 1 }, "was" : { "," : 1 },
         "now" : { "they" : 1 }, "they" : { "keep" : 1 }, "keep" : { "on" : 1 },
         "forever" : { "just" : 1 }, "just" : { "because" : 1 }, 
         "because" : { "." : 1 }, "." : { "." : 2 } })
    print("... done!")

def test_week1():
    test_load_book()
    test_get_corpus_length()
    test_build_vocabulary()
    test_count_unigrams()
    test_get_start_words()
    test_count_start_words()
    test_count_bigrams()

test_week1()
do_week1()

#### CHECK-IN 2 ####

"""
Since we can compute the list of all of the words in the corpus using
build_vocabulary(corpus), we could think of predicting the next word in the
text as just a random choice of these words.

Write a function build_uniform_probs(unigrams) which takes a list of unique unigrams
and returns a new list of the same length where the value is 1/len(unigrams)
at each index.  Each index of this new list represents the probability
that the corresponding index in unigrams would be chosen at random. Return the
list of probabilities.
"""
def build_uniform_probs(unigrams):
    return

"""
Another way to compute the words in the text is by how frequently they occur.
You computed the counts of all the unigrams last week. This week we will use them
to compute the probability of that word being randomly chosen from the whole book.

Write a function build_unigram_probs(unigrams, unigram_counts, total_count)
which takes a list of all of the unique words in the book, a dictionary mapping
unique unigrams to counts, and the total count of words in the book, and returns
a new list of the probabilities of each word.

In order to do this, you should:
1) make a new empty list
2) iterate through the indexes of the unigram list
    a) look up the count of the corresponding unigram in the unigram_counts,
    b) divide count/total_count, and
    c) append that probability to the list.
The probability at index i will be the probability that the word at the same index
in unigrams would be chosen at random from the book. Return the list of probabilities.
"""
def build_unigram_probs(unigrams, unigram_counts, total_count):
    return

"""
Finally, we can also think about how the probability of one word changes based on
the word before it. Think about the word "Happy". The word "birthday" and "Halloween"
probably occur at a much higher rate after "Happy" than after other words.

Write a function build_bigram_probs(unigram_counts, bigram_counts) that takes the
frequencies of single words (unigram_counts) and of pairs of words (bigram_counts)
and returns a new 2D dictionary of the probabilities of a second word being chosen
after the first.

1) Make a new dictionary
2) Iterate through each key prev_word in bigram_count
    a) bigram_count[prev_word] is a dictionary of all the words that occurred
        after prev_word in the book.
    b) make two new lists, one for the words (keys) in bigram_count[prev_word],
        and one for the probabilities of those words
    c) iterate through all of the keys in bigram_count[prev_word], appending the
        key to the key list and the key's value count divided by unigram_count[prev_word]
        to the probability list.
            Note 1: unigram_count[key] represents the total # of times the 
            prev_word occurred. That total is divided by all the words that
            were seen after it. One of those words is key, so the probability of 
            that word is the count of how many times it was seen after 
            prev_word / count of prev_word.
            Note 2: this isn't 100% accurate, because we might have fewer
            total word occurences in bigram_count than unigram_count if a
            prev_word occurred at the end of a sentence. But this usually only
            happens to punctuation, so we'll say this is good enough for now.
    d) make a dictionary mapping the word "words" to the key list and the word
        "probs" to the list of probabilities.
    e) add to the new dictionary the key prev_word; the value is the dictionary
        from part d
3) Return the new dictionary.
"""
def build_bigram_probs(unigram_count, bigram_count):
    return

"""
Write a function get_top(count, words, probs, ignorelist) which takes an int count,
a list of words, and the list of the corresponding probabilities. It finds the top
count highest probabilities, then returns a dictionary mapping those highest 
probability words to their probabilities as values. Only include words that 
aren't in the list of words ignorelist.

One way to do this is to create an empty dictionary which will hold the known 
highest probability words, then repeatedly search for the highest probability word 
that is not already a key in that dictionary and not in the ignorelist. When you 
finish iterating to find the highest probability word, add it to the dictionary.
Continue the process until the length of the dictionary == count.
"""
def get_top(count, words, probs, ignorelist=[]):
    return

"""
Write a function generate_text_unigrams(count, words, probs) which takes in a count
of the number of words to generate, the word list, and the corresponding probabilities,
and returns a string created by concatenating probabilistically-chosen words together.

Use the function choices(words, weights=probs) from the random library to generate 
a random word sampled according to the given probability distribution. choices 
returns a list containing the word it picked.

Don't forget to add spaces between words! And return the text once you've added 
count words.
"""
from random import choices
def generate_text_unigrams(count, words, probs):
    return

"""
Write a function generate_text_bigrams(count, start_words, start_word_probs, bigram_probs)
which takes in a count of the number of words to generate, the start word list,
the start word probabilities, and the bigram probabilities dictionary, and outputs 
a string of count words generated probabilistically.

In order to generate words, we follow one of two cases:

First, if nothing has been seen yet or a period has been seen indicating the end 
of a sentence, use the choices function with start_words and start_word_probs to
generate a new word.

Otherwise, look up in the bigram_probs dictionary the last word generated. Use 
the "words" and "probs" lists in the dictionary as parameters to choices, then 
append the word onto the text you've generated so far.

Don't forget to include spaces between words! And return the text once you've 
added count words.
"""
def generate_text_bigrams(count, start_words, start_word_probs, bigram_probs):
    return


def do_week2():
    # Check-in 1 Functions
    book = load_book("data/fairytales_clean.txt")
    length = get_corpus_length(book)
    uniquewords = build_vocabulary(book)
    startwords = get_start_words(book)
    countunigrams = count_unigrams(book)
    countstartwords = count_start_words(book)
    countbigrams = count_bigrams(book)
    
    # Uniform Model
    uniformprobs = build_uniform_probs(uniquewords)
    print("\nText generated by the Uniform Model:\n")
    print(generate_text_unigrams(100,uniquewords,uniformprobs))
    print("\n-----\n")
    
    # Unigram Model
    unigramprobs = build_unigram_probs(uniquewords, countunigrams, length)
    startwordprobs = build_unigram_probs(startwords,countstartwords, len(book))
    print("Top 20 words in the Unigram Model:")
    print(get_top(20,uniquewords,unigramprobs))
    print("\nTop 20 starting words in the Unigram Model:")
    print(get_top(20,startwords,startwordprobs))
    print("\nText generated by the Unigram Model:\n")
    print(generate_text_unigrams(100,uniquewords,unigramprobs))
    print("\n-----\n")
    
    # Bigram Model
    bigramprobs = build_bigram_probs(countunigrams,countbigrams)
    print("Text generated by the Bigram Model:\n")
    print(generate_text_bigrams(100,startwords, startwordprobs, bigramprobs))

#### WEEK 2 TESTS ####

def test_build_uniform_probs():
    print("Testing build_uniform_probs()...", end="")
    assert(build_uniform_probs([ "hello", "world", "again"]) == [1/3, 1/3, 1/3])
    assert(build_uniform_probs([ "hello", "and", "welcome", "to", "15-110", ".",
           "we're", "happy", "have", "you"]) == [ 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 
           0.1, 0.1, 0.1, 0.1 ])
    assert(build_uniform_probs([ "this", "is", "the", "song", "that", "never", 
           "ends", "yes", "it", "goes", "on", "and", "my", "friends", "!", "some",
           "people", "started", "singing", ",", "not", "knowing", "what", "was", 
           "now", "they", "keep", "forever", "just", "because", "." ]) == [1/31, 
           1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 
           1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 1/31, 
           1/31, 1/31, 1/31, 1/31, 1/31, 1/31 ])
    print("... done!")
    
def test_build_unigram_probs():
    print("Testing build_unigram_probs()...", end="")
    assert(build_unigram_probs([ "hello", "world", "again"], { "hello" : 2, 
           "world" : 2, "again" : 1 }, 5 ) == [2/5, 2/5, 1/5])
    assert(build_unigram_probs([ "hello", "and", "welcome", "to", "15-110", ".",
           "we're", "happy", "have", "you"], { "hello" : 1, "and" : 1,
           "welcome" : 1, "to" : 2, "15-110" : 1, "." : 2, "we're" : 1, 
           "happy" : 1, "have" : 1, "you" : 1 }, 12) == [1/12, 1/12, 1/12, 2/12, 
           1/12, 2/12, 1/12, 1/12, 1/12, 1/12])
    assert(build_unigram_probs([ "this", "is", "the", "song", "that", "never", 
           "ends", "yes", "it", "goes", "on", "and", "my", "friends", "!", "some",
           "people", "started", "singing", ",", "not", "knowing", "what", "was", 
           "now", "they", "keep", "forever", "just", "because", "." ], { 
           "this" : 1, "is" : 1, "the" : 1, "song" : 1, "that" : 1, "never" : 1, 
           "ends" : 1, "yes" : 1, "it" : 4, "goes" : 1, "on" : 3, "and" : 2, 
           "my" : 1, "friends" : 1, "!" : 1, "some" : 1, "people" : 1, 
           "started" : 1, "singing" : 2, "," : 2, "not" : 1, "knowing" : 1, 
           "what" : 1, "was" : 1, "now" : 1, "they" : 1, "keep" : 1, 
           "forever" : 1, "just" : 1, "because" : 1, "." : 3 }, 41) == [
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 4/41, 1/41, 3/41, 2/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 2/41, 2/41, 1/41, 1/41, 1/41, 1/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 3/41])
    print("... done!")

def test_build_bigram_probs():
    print("Testing build_bigram_probs()...", end="")
    assert(build_bigram_probs({ "hello" : 2, "world" : 2, "again" : 1 }, { 
           "hello" : { "world" : 2 }, "world" : { "again" : 1 } }) == {
           "hello" : { "words" : ["world"], "probs" : [1] },
           "world" : { "words" : ["again"], "probs" : [0.5] } }) # since 'world'
           # appears twice, once at the end of a sentence
    assert(build_bigram_probs({ "hello" : 1, "and" : 1, "welcome" : 1, "to" : 2,
           "15-110" : 1, "." : 2, "we're" : 1, "happy" : 1, "have" : 1, 
           "you" : 1 }, { "hello" : { "and" : 1 }, "and" : { "welcome" : 1 }, 
           "welcome" : { "to" : 1 }, "to" : { "15-110" : 1, "have" : 1 }, 
           "15-110" : { "." : 1 }, "we're" : { "happy" : 1 }, 
           "happy" : { "to" : 1 }, "have" : { "you" : 1 }, 
           "you" : { "." : 1 } }) == { "hello" : { "words" : ["and"], "probs" : [1] },
           "and" : { "words" : ["welcome"], "probs" : [1] },
           "welcome" : { "words" : ["to"], "probs" : [1] },
           "to" : { "words" : ["15-110", "have"], "probs" : [0.5, 0.5] },
           "15-110" : { "words" : ["."], "probs" : [1] },
           "we're" : { "words" : ["happy"], "probs" : [1] },
           "happy" : { "words" : ["to"], "probs" : [1] },
           "have" : { "words" : ["you"], "probs" : [1] },
           "you" : { "words" : ["."], "probs" : [1] } })
    assert(build_bigram_probs({ "this" : 1, "is" : 1, "the" : 1, "song" : 1, 
           "that" : 1, "never" : 1, "ends" : 1, "yes" : 1, "it" : 4, "goes" : 1, 
           "on" : 3, "and" : 2, "my" : 1, "friends" : 1, "!" : 1, "some" : 1, 
           "people" : 1, "started" : 1, "singing" : 2, "," : 2, "not" : 1, 
           "knowing" : 1, "what" : 1, "was" : 1, "now" : 1, "they" : 1, "keep" : 1, 
           "forever" : 1, "just" : 1, "because" : 1, "." : 3 }, { 
           "this" : { "is" : 1 }, "is" : { "the" : 1 }, "the" : { "song" : 1 }, 
           "song" : { "that" : 1 }, "that" : { "never" : 1 }, 
           "never" : { "ends" : 1 }, "yes" : { "it" : 1 }, 
           "it" : { "goes" : 1, "," : 1, "was" : 1, "forever" : 1 }, 
           "goes" : { "on" : 1 }, "on" : { "and" : 1, "my" : 1, "singing" : 1 }, 
           "and" : { "on" : 1, "now" : 1 }, "my" : { "friends" : 1}, 
           "friends" : { "!" : 1 }, "some" : { "people" : 1 }, 
           "people" : { "started" : 1 }, "started" : { "singing" : 1 }, 
           "singing" : { "it" : 2 }, "," : { "not" : 1 }, "not" : { "knowing" : 1 },
           "knowing" : { "what" : 1 }, "what" : { "it" : 1 }, "was" : { "," : 1 },
           "now" : { "they" : 1 }, "they" : { "keep" : 1 }, "keep" : { "on" : 1 },
           "forever" : { "just" : 1 }, "just" : { "because" : 1 }, 
           "because" : { "." : 1 }, "." : { "." : 2 } }) == { 
           "this" : { "words" : ["is"], "probs" : [1] },
           "is" : { "words" : ["the"], "probs" : [1] },
           "the" : { "words" : ["song"], "probs" : [1] },
           "song" : { "words" : ["that"], "probs" : [1] },
           "that" : { "words" : ["never"], "probs" : [1] },
           "never" : { "words" : ["ends"], "probs" : [1] },
           "yes" : { "words" : ["it"], "probs" : [1] },
           "it" : { "words" : ["goes", ",", "was", "forever"], "probs" : [0.25, 0.25, 0.25, 0.25] },
           "goes" : { "words" : ["on"], "probs" : [1] },
           "on" : { "words" : ["and", "my", "singing"], "probs" : [1/3, 1/3, 1/3] },
           "and" : { "words" : ["on", "now"], "probs" : [0.5, 0.5] },
           "my" : { "words" : ["friends"], "probs" : [1] },
           "friends" : { "words" : ["!"], "probs" : [1] },
           "some" : { "words" : ["people"], "probs" : [1] },
           "people" : { "words" : ["started"], "probs" : [1] },
           "started" : { "words" : ["singing"], "probs" : [1] },
           "singing" : { "words" : ["it"], "probs" : [1] },
           "," : { "words" : ["not"], "probs" : [0.5] }, # because the total count of "," is 2, with one at the end
           "not" : { "words" : ["knowing"], "probs" : [1] },
           "knowing" : { "words" : ["what"], "probs" : [1] },
           "what" : { "words" : ["it"], "probs" : [1] },
           "was" : { "words" : [","], "probs" : [1] },
           "now" : { "words" : ["they"], "probs" : [1] },
           "they" : { "words" : ["keep"], "probs" : [1] },
           "keep" : { "words" : ["on"], "probs" : [1] },
           "forever" : { "words" : ["just"], "probs" : [1] },
           "just" : { "words" : ["because"], "probs" : [1] },
           "because" : { "words" : ["."], "probs" : [1] },
           "." : { "words" : ["."], "probs" : [2/3] } }) # because the total count is 3
    # One final test to make sure probabilities aren't always the same
    assert(build_bigram_probs({ "one" : 3 }, { "one" : { "a" : 1, "b" : 2 } }) == {
        "one" : { "words" : ["a", "b"], "probs" : [1/3, 2/3] } })
    print("... done!")

def test_get_top():
    print("Testing get_top()...", end="")
    assert(get_top(2, [ "hello", "world", "again"], [2/5, 2/5, 1/5]) == { 
           "hello" : 2/5, "world" : 2/5 })
    assert(get_top(3, [ "hello", "world", "again"], [2/5, 2/5, 1/5]) == {
           "hello" : 2/5, "world" : 2/5, "again" : 1/5 })
    assert(get_top(2, [ "hello", "and", "welcome", "to", "15-110", ".",
           "we're", "happy", "have", "you"], [1/12, 1/12, 1/12, 2/12, 
           1/12, 2/12, 1/12, 1/12, 1/12, 1/12]) == { "to" : 2/12, "." : 2/12 })
    assert(get_top(3, [ "hello", "and", "welcome", "to", "15-110", ".",
           "we're", "happy", "have", "you"], [1/12, 1/12, 1/12, 2/12, 
           1/12, 2/12, 1/12, 1/12, 1/12, 1/12], [".", "hello", "and", "15-110", 
           "we're", "have", "you"]) == { "to" : 2/12, "welcome" : 1/12, 
           "happy" : 1/12 })
    assert(get_top(1, [ "this", "is", "the", "song", "that", "never", 
           "ends", "yes", "it", "goes", "on", "and", "my", "friends", "!", "some",
           "people", "started", "singing", ",", "not", "knowing", "what", "was", 
           "now", "they", "keep", "forever", "just", "because", "." ], [
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 4/41, 1/41, 3/41, 2/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 2/41, 2/41, 1/41, 1/41, 1/41, 1/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 3/41]) == { "it" : 4/41 })
    assert(get_top(3, [ "this", "is", "the", "song", "that", "never", 
           "ends", "yes", "it", "goes", "on", "and", "my", "friends", "!", "some",
           "people", "started", "singing", ",", "not", "knowing", "what", "was", 
           "now", "they", "keep", "forever", "just", "because", "." ], [
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 4/41, 1/41, 3/41, 2/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 2/41, 2/41, 1/41, 1/41, 1/41, 1/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 3/41]) == { "it" : 4/41, 
           "on" : 3/41, "." : 3/41 })
    assert(get_top(6, [ "this", "is", "the", "song", "that", "never", 
           "ends", "yes", "it", "goes", "on", "and", "my", "friends", "!", "some",
           "people", "started", "singing", ",", "not", "knowing", "what", "was", 
           "now", "they", "keep", "forever", "just", "because", "." ], [
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 4/41, 1/41, 3/41, 2/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 2/41, 2/41, 1/41, 1/41, 1/41, 1/41,
           1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 3/41]) == { "it" : 4/41, 
           "on" : 3/41, "." : 3/41, "and" : 2/41, "singing" : 2/41, "," : 2/41 })
    print("... done!")

def test_generate_text_unigrams():
    print("Testing generate_text_unigrams()...", end="")
    # Since this is random, we can only check that it's the right length
    # and that it only uses words in the provided list.
    words, probs = [ "hello", "world", "again"], [2/5, 2/5, 1/5]
    sentence = generate_text_unigrams(5, words, probs)
    assert(len(sentence.strip().split(" ")) == 5)
    for word in sentence.strip().split(" "):
        assert(word in words)

    words, probs = [ "hello", "and", "welcome", "to", "15-110", ".", "we're", 
        "happy", "have", "you"], [1/12, 1/12, 1/12, 2/12, 1/12, 2/12, 1/12, 1/12,
        1/12, 1/12]
    sentence = generate_text_unigrams(10, words, probs)
    assert(len(sentence.strip().split(" ")) == 10)
    for word in sentence.strip().split(" "):
        assert(word in words)
    
    words, probs = [ "this", "is", "the", "song", "that", "never", "ends", "yes", 
        "it", "goes", "on", "and", "my", "friends", "!", "some", "people", 
        "started", "singing", ",", "not", "knowing", "what", "was", "now", "they",
        "keep", "forever", "just", "because", "." ], [1/41, 1/41, 1/41, 1/41, 1/41, 
        1/41, 1/41, 1/41, 4/41, 1/41, 3/41, 2/41, 1/41, 1/41, 1/41, 1/41, 1/41, 
        1/41, 2/41, 2/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 1/41, 
        1/41, 3/41]
    sentence = generate_text_unigrams(20, words, probs)
    assert(len(sentence.strip().split(" ")) == 20)
    for word in sentence.strip().split(" "):
        assert(word in words)
    print("... done!")

def test_generate_text_bigrams():
    print("Testing generate_text_bigrams()...", end="")
    # Since we assume . is used as a stopping point, include it specifically in
    # the test set.
    
    start_words, start_probs = [ "hi", "dear" ], [ 0.6, 0.4]
    bigram_probs = { "hi" : { "words" : [",", "how"], "probs" : [0.8, 0.2] },
        "dear" : { "words" : [ "sir", "madam" ], "probs" : [0.5, 0.5] },
        "," : { "words" : ["what's", "sup", "yeet"], "probs" : [0.3, 0.3, 0.4] },
        "how" : { "words" : ["are"], "probs" : [1] },
        "sir" : { "words" : [".", ","], "probs" : [0.8, 0.2] },
        "madam" : { "words" : [ ".", ","], "probs" : [0.8, 0.2] },
        "what's" : { "words" : [ "up" ], "probs" : [1] },
        "sup" : { "words" : [ "." ], "probs" : [1] },
        "yeet" : { "words" : [ "!" ], "probs" : [1] },
        "are" : { "words" : [ "you", "yeet" ], "probs" : [0.9, 0.1] },
        "up" : { "words" : [ ".", "," ], "probs" : [0.5, 0.5] },
        "!" : { "words" : ["!", "."], "probs" : [0.7, 0.3] },
        "you" : { "words" : ["."], "probs" : [1] } }
    sentence = generate_text_bigrams(10, start_words, start_probs, bigram_probs)
    sentence_words = sentence.strip().split()
    assert(len(sentence_words) == 10)
    for i in range(len(sentence_words)):
        if i == 0 or sentence_words[i-1] == ".":
            assert(sentence_words[i] in start_words)
        else:
            assert(sentence_words[i] in bigram_probs[sentence_words[i-1]]["words"])
    print("... done!")

def test_week2():
    test_build_uniform_probs()
    test_build_unigram_probs()
    test_build_bigram_probs()
    test_get_top()
    test_generate_text_unigrams()
    test_generate_text_bigrams()

test_week2()
do_week2()

#### FULL ASSIGNMENT ####

import matplotlib.pyplot as plt

ignore = [ ",", ".", "?", "'", '"', "-", "!", ":", ";", "by", "around", "over", 
           "a", "on", "be", "in", "the", "is", "on", "and", "to", "of", "it", 
           "as", "an", "but", "at", "if", "so", "was", "were", "for", "this", 
           "that", "onto", "from", "not", "into" ]

"""
Write a function graph_top_50_words(corpus) which takes as input a corpus, uses the
functions from previous weeks to compute the unigrams and the unigram probabilities, 
and then computes the top 50 most frequent words according to the probabilities 
(using get_top and the global ignore list defined above to eliminate common words 
with no meaning).

Then, using the most common 50 words and their probabilities, calls our bar_plot
function with a good title to display the words.
"""
def graph_top_50_words(corpus):
    return

"""
Write a function graph_top_start_words(corpus) which takes as input a corpus and 
uses the functions from previous weeks to compute the start words and the start 
word probabilities, then computes the top 50 most frequent start words according 
to the probabilities (using get_top and the global ignore list defined above to
eliminate common words with no meaning).

Then, using the most common start words and their probabilities, call our bar_plot
function with a good title to display the words.
"""
def graph_top_start_words(corpus):
    return

"""
Write a function graph_bigram_words(corpus, word) which takes a corpus and word
and graphs the top 10 words that appear after that word in the corpus, not
counting words in the global ignore list.

Hint: what does the build_bigram_probs compute? What does the get_top function
compute? Can you use those in conjunction with each other to get the top 10 words
that appear after a word?
"""
def graph_bigram_words(corpus, word):
    return

"""
Write a function graph_sidebyside(corpus1, name1, corpus2, name2, title) which 
takes two corpuses (corpora) and their names. Then it should find the top 50 
unigrams in corpus1 (ignoring words in the ignore list), the corresponding
probabilities in corpus1, and also a list of the corresponding probabilities in 
corpus2. It should do the same with corpus2 for the top 50 words in corpus2 (again
ignoring words in the ignore list), again finding the probabilities in corpus2 
and in corpus1.

The function should then combine these two sets of lists to make one result with 
the union of the top 50 words in corpus1 and the top 50 words in corpus2 (noting 
that some words might appear in both, and should not be repeated). Finally, it 
should use sidebyside_bar_plots to show the differences in probabilities across
those top elements. Use name1 and name2 as the category names, and don't forget 
to include the title- this time, it's provided for you.
"""
def graph_sidebyside(corpus1, name1, corpus2, name2, title):
    return

"""
Write a function graph_scatterplot(corpus1, corpus2, title) which takes two corpuses 
(corpora). It should find the top 30 unigrams in corpus1 and the corresponding
probabilities in corpus1, and also a list of the corresponding probabilities in 
corpus2. It should do the same with corpus2 for top 30 words in that corpus, again
finding probabilities for both corpora. Finally, it should use the scatter_plot 
function to show the probabilities of corpus1 on the x axis and corpus2 on the y. 
Don't forget to include the title- this time, it's provided for you. 

Note: when calling scatter_plot, the parameters x, y, and labels must be lists.
"""
def graph_scatterplot(corpus1, corpus2, title):
    return

def do_week3():
    book1 = load_book("data/grimm_clean.txt")
    book2 = load_book("data/andersen_clean.txt")
    graph_top_50_words(book1)
    graph_top_start_words(book1)
    graph_bigram_words(book1, "said")
    graph_bigram_words(book2, "said")
    graph_bigram_words(book1, "good")
    graph_bigram_words(book2, "good")
    graph_sidebyside(book1, "Grimm", book2, "Andersen", "Top 50 words in Grimm vs Andersen")
    graph_scatterplot(book1, book2, "Top 50 words in Grimm vs Andersen")

#### WEEK 3 PROVIDED CODE ####

"""
Expects a dictionary of words as keys with probabilities as values, and a title
Plots the words on the x axis, probabilities as the y axis and puts a title on top.
"""
def bar_plot(dict, title):
    names = list(dict.keys())
    values = list(dict.values())
    plt.bar(names, values)
    plt.xticks(names, rotation='vertical')
    plt.title(title)
    plt.show()

"""
Expects 3 lists - one of names, and two of values such that the index of a name
corresponds to a value at the same index in both lists. Category1 and Category2
are the labels for the different colors in the graph. For example, you may use
it to graph two categories of probabilities side by side to look at the differences.
"""
def sidebyside_bar_plots(names, values1, values2, category1, category2, title):
    x = list(range(len(names)))  # the label locations
    width = 0.35  # the width of the bars
    fig, ax = plt.subplots()
    pos1 = []
    pos2 = []
    for i in x:
        pos1.append(i - width/2)
        pos2.append(i + width/2)
    rects1 = ax.bar(pos1, values1, width, label=category1)
    rects2 = ax.bar(pos2, values2, width, label=category2)
    ax.set_xticks(x)
    ax.set_xticklabels(names)
    ax.legend()
    plt.title(title)
    plt.xticks(rotation="vertical")
    fig.tight_layout()
    plt.show()

"""
Expects two lists of probabilities and a list of labels (words) all the same length
and plots the probabilities of x and y, labels each point, and puts a title on top.
"""
def scatter_plot(xs, ys, labels, title):
    plt.scatter(xs, ys)

    # make labels for the points
    for i in range(len(labels)):
        plt.annotate(labels[i], # this is the text
                    (xs[i], ys[i]), # this is the point to label
                    textcoords="offset points", # how to position the text
                    xytext=(0, 10), # distance from text to points (x,y)
                    ha='center') # horizontal alignment can be left, right or center
    plt.title(title)
    plt.xlim(0, 0.02)
    plt.ylim(0, 0.02)
    plt.show()

#### WEEK 3 TESTS ####

# Instead of running individual tests, check the new graph generated by do_week3
# after you finish each function.

do_week3()